/*  See noise1sec.c.  In contrast, this variant makes noise whose spectrum
is triangular, bandlimited to Nyquist/4. */

#include "/usr/include/sound/soundstruct.h"
SNDSoundStruct header =
{
	SND_MAGIC,
	sizeof(SNDSoundStruct),
	0x10000000,
	SND_FORMAT_LINEAR_16,
	32000,
	1,
	0x62617a00
};

#include "math.h"
#include "stdio.h"
#define NPOINTS 32000

float frand()
{
	return (random()* (1./2147483648.));
}

#define FILTSIZE2 400
float filt2[FILTSIZE2];

float dot(float *a, float *b, int n)
{
	float ret = 0;
	for (; n--; a++, b++) ret += *a * *b;
	return (ret);
}

main()
{
	float norm = sqrt(3.)/5., f, *fp;
	short sbuf[NPOINTS];
	float fbuf[NPOINTS], fbuf2[NPOINTS + FILTSIZE2];
	int i, j;
	for (i = 0; i < NPOINTS; i += 1)
		fbuf2[i] = frand() - .5;
		/* fbuf2 will wrap around. */
	for (i = NPOINTS; i < NPOINTS + FILTSIZE2; i += 1)
		fbuf2[i] = fbuf2[i-NPOINTS];

		/* make a 400-point (sin(x)/x)^2 filter kernel */
	for (i = 0; i < FILTSIZE2-1; i++)
	{
		if (i != (FILTSIZE2-2)/2)
		{
			float phase = ((((float)i) - .5 * (FILTSIZE2-2))/(.5 * (FILTSIZE2-2)));
			filt2[i] = .5 * (1 + cos(3.14159*phase)) *
				sin(3.14159 * .0625 * (FILTSIZE2-2) * phase) * 
				sin(3.14159 * .0625 * (FILTSIZE2-2) * phase) /
					((3.14159 * .0625 * (FILTSIZE2-2) * phase) *
					(3.14159 * .0625 * (FILTSIZE2-2) * phase));
		}
		else filt2[i] = 1;
		/* fprintf(stderr, "%f\n", filt2[i]); */
	}
	filt2[FILTSIZE2-1] = 0;
		
			/* filter fbuf2 into fbuf */
	for (i = 0; i < NPOINTS; i++)
		fbuf[i] = dot(fbuf2+i, filt2, FILTSIZE2);
	
	/* for (i = 0; i < FILTSIZE2; i++) printf("%f\n", filt2[i]);
	printf("--------\n"); */

	for (i = 200; i < 220; i ++) fprintf(stderr, "%f\n", fbuf[i]);
	for (f = 0, i = 0; i < NPOINTS; i++)
	{
		if (fbuf[i] > f) f = fbuf[i];
		else if (fbuf[i] < -f) f = -fbuf[i];
	}
	fprintf(stderr, "maximum %f\n", f);
	for (i = 0; i < NPOINTS; i++)
	{
		sbuf[i] = (32767 * fbuf[i]) / f;
	}
	if (write(1, &header, sizeof(header)) < sizeof(header) ||
		write(1, sbuf, sizeof(sbuf)) < sizeof(sbuf) ||
		write(1, sbuf, sizeof(sbuf)) < sizeof(sbuf))
	{
		perror("write");
		exit(1);
	}
	exit(0);
}
